"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.toSubscriber = exports.isObservable = exports.inferType = exports.inferPath = void 0;
var rxjs_1 = require("rxjs");
function inferPath(observable) {
    var source = observable.source;
    if (source) {
        return inferPath(source) + "/" + inferType(observable);
    }
    return "/" + inferType(observable);
}
exports.inferPath = inferPath;
function inferType(observable) {
    var operator = observable.operator;
    var prototype = Object.getPrototypeOf(operator ? operator : observable);
    if (prototype.constructor && prototype.constructor.name) {
        var name_1 = prototype.constructor.name;
        name_1 = "" + name_1.charAt(0).toLowerCase() + name_1.substring(1);
        return name_1.replace(/^(\w+)(Observable|Operator)$/, function (match, p) { return p; });
    }
    return "unknown";
}
exports.inferType = inferType;
function isObservable(arg) {
    return arg && arg.subscribe;
}
exports.isObservable = isObservable;
var empty = {
    closed: true,
    error: function (error) {
        throw error;
    },
    next: function (value) { },
    complete: function () { },
};
var SubscriberSymbol = Symbol.for("rxSubscriber");
var SpySubscriber = (function (_super) {
    __extends(SpySubscriber, _super);
    function SpySubscriber(observer) {
        var _this = _super.call(this) || this;
        _this.destination = observer;
        return _this;
    }
    return SpySubscriber;
}(rxjs_1.Subscriber));
function toSubscriber(observerOrNext, error, complete) {
    if (observerOrNext instanceof rxjs_1.Subscriber) {
        return observerOrNext;
    }
    var next;
    if (typeof observerOrNext === "function") {
        next = observerOrNext;
    }
    else if (observerOrNext) {
        (complete = observerOrNext.complete, error = observerOrNext.error, next = observerOrNext.next);
        next = next ? function (value) { return observerOrNext.next(value); } : undefined;
        error = error ? function (error) { return observerOrNext.error(error); } : undefined;
        complete = complete ? function () { return observerOrNext.complete(); } : undefined;
    }
    return new SpySubscriber({
        complete: complete !== null && complete !== void 0 ? complete : rxjs_1.noop,
        error: error !== null && error !== void 0 ? error : (function (error) {
            throw error;
        }),
        next: next !== null && next !== void 0 ? next : rxjs_1.noop,
    });
}
exports.toSubscriber = toSubscriber;
